/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.mandarax.util;

import org.mandarax.kernel.Clause;
import org.mandarax.kernel.Fact;

/**
 * Clause iterator for auto facts.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.2
 */
class SingleAutoFactIterator extends AbstractAutoFactIterator {

	private Fact fact = null;
	private boolean more = false;

	/**
	 * Constructor.
	 * @param f org.mandarax.kernel.Fact
	 * @param af the client object
	 */
	public SingleAutoFactIterator(Fact f, AutoFacts af) {
		super(af);
		fact = f;
		initialize();
	}

	/**
	 * Indicates whether there are more clauses.
	 * @return boolean
	 */
	public boolean hasMoreClauses() {
		if (more) {
			more = false;

			return true;
		}
		return more;
	}
	/**
	 * Initialize the object.
	 */
	private void initialize() {
		more = perform(fact,null);
		fact.setContainer(autofacts);
	}
	/**
	 * Get the next clause.
	 */
	public Clause nextClause() {
		return fact;
	}
}
